c
c common for signal finding algorythms
c
c hec_s_chan (1..i_adc_dim)      .FALSE. = no signal in channel i
c                                .TRUE.  =    signal in channel i
c
c hec_s_ped (1..i_adc_dim)       pedestal of adc i      (copy of adc_ped())
c hec_s_sig (1..i_adc_dim)       pedestal rms of adc i  (copy of adc_rms())
c
c hec_s_in(1..i_adc_dim,1..i_tim_dim)         ==> INPUT array
c     essentially a 2dimentional copy of adc data
c
c hec_s_result(1..i_adc_dim,1..i_tim_dim)     ==> OUTPUT array
c     if searching is switched on:   (hec_s_k > 0)
c               timeslices of an active channel (3rd array element is Maximum)
c               zeros for inactive channel
c     if searching is switched off:  (hec_s_k = 0)
c               unchaned timeslices for all channels
c
c hec_s_k  kind of search algorythm  (-> from datacard)
c
c hec_s_start start timeslice to search maximum
c hec_s_stop  stop timeslice to search maximum
c
c hec_s_five, hec_s_seven  logical indicating the # of time slices to look at
c              puls shape:  hec_s_five =.FALSE.
c                           hec_s_seven=.FALSE.    => take 3 timeslices
c
c                           hec_s_five =.TRUE.
c                           hec_s_seven=.FALSE.    => take 5 timeslices
c
c                           hec_s_five =.TRUE.
c                           hec_s_seven=.TRUE.     => take 7 timeslices
c
c hec_s_lvl                sigma level to accept an event
c
c hec_s_im(1..i_adc_dim)   if signal was found:
c                           index (=# of timeslice) of the maximum
c                          if no signal found:
c                            0
c                          OUTPUT of the search routine/function
c
c hec_s_mc                 apply the sigmacut for searching or not
c
c hec_s_hit                .TRUE. at least one signal shape found
c
c hec_s_cells              counts the number of active cells in one event
c
c hec_s_count(1..i_adc_dim) counts how often a channel was active in a run
c

      integer hec_s_im(i_adc_dim), hec_s_cells
      integer hec_s_count(i_adc_dim)
      logical hec_s_five, hec_s_seven, hec_s_hit
      logical hec_s_chan(i_adc_dim)
      real hec_s_ped(i_adc_dim), hec_s_sig(i_adc_dim)
      real hec_s_in(i_adc_dim,i_tim_dim)
      real hec_s_result(i_adc_dim,i_tim_dim)
      integer hec_s_k, hec_s_start, hec_s_stop, hec_s_tcomp
      logical hec_s_mc
      real hec_s_lvl
      
      common /ssshec_s/ hec_s_chan, hec_s_ped, hec_s_sig, hec_s_in,
     &                  hec_s_result, hec_s_hit, hec_s_im, hec_s_five,
     &                  hec_s_seven, hec_s_cells, hec_s_count,
     &                  hec_s_k, hec_s_start, hec_s_stop, hec_s_tcomp,
     &                  hec_s_mc, hec_s_lvl
