      PROGRAM hec_adc
c
c program to provide simple access to atlas hadronic endcap 
c testbeam data
c Michel Lefebvre
c Dugan O'Neil
c
c version 3.2   12/04/98
c THIS VERSION IS A PRE-RELEASE, AWAITING VERSION 4.0
c
c see file hec_adc.versions for an update of the code versions
c see file hec_adc.readme for information
c
c please send comments to uvatlas@uvic.ca
c
      implicit none
c
c user datacard values common
c
      include'hec_datacard.inc'
c
c system initialization
c
      call hec_ini
c
c offline mode
c
      if (run_mode .eq. 1) then
c
c pedestal package
c
        call hec_ped
c
c channel/time correlation package
c
        call hec_crl
c
c peak finding package using simple cubic fit
c
        call hec_cub
c
c calibration package
c
        call hec_cal
c
c beam chamber reconstruction package
c
        call hec_beam
c
c system histograms package
c
        call hec_his
c
c standard ntuple package
c
        call hec_ntuple
c
c user initialization
c
        call user_ini
c
c pass 1 over data set for user
c
        if (n_pass .ge. 1) call hec_pass1
c
c pass 2 over data set for user
c
        if (n_pass .ge. 2) call hec_pass2
c
c pass 3 over data set for user
c
        if (n_pass .ge. 3) call hec_pass3
c
c user termination
c
        call user_ter
c
c online package
c
      elseif (run_mode .eq. 2) then
        call hec_online 
      endif
c
c termination
c
      call hec_ter
c
      end
