      subroutine hec_ini
c
c 03/12/96  ML  improve order of calls to allow proper hbook handling
c 11/03/97  ML  include user_card and hec_card routines.
c 02/05/97  ML  rewritten.  
c               user initialization now after system packages.
c
c initialization routine
c
c  1- sys datacard (ffread) initialization
c  2- user datacard initialization
c  3- read datacards
c  4- prepare searching flags
c  5- data io initialization
c  6- hbook initialization
c  7- fill geometry correspondence tables
c
      implicit none
c
      include'hec_datacard.inc'
c
c datacard initialization
c
      call hec_card
c
c user datacard initialization
c
      call user_card
c
c read user datacards
c
      call ffgo
      close(unit=13)
c
c data io initialization
c
      call hec_io_ini
c
c hbook initialization
c
      call hec_hbook_ini
c
c prepare searching flags
c
      if (run_mode .ne. 2) call hec_s_flagini
c
c
c fill geometry correspondence tables and clear channels
c (only if offline mode)
c
      if ( run_mode .ne. 2) then
        call hec_geo
      endif
c
      print *,' *** initialization done'
c
      end

