      subroutine hec_ntuple_evt1
c
c pass 1 standard ntuples filling event routine
c
      implicit none
      include'hec_par.inc'
c
c adc values
c must be preceded by the include file hec_par.inc
c
      include'hec_adc.inc'
c
c calibrated energies common
c must be preceded by the include file hec_par.inc
c
      include'hec_cal.inc'
c
c common for datacard values
c
      include'hec_datacard.inc'
c
c event header common
c
      include'hec_evth.inc'
c
c geometry correspondence tables common
c must be preceded by the include file hec_par.inc
c
      include'hec_geo.inc'
c
c system histogram id common
c
      include'hec_his_sys.inc'
c
c max adc and time values common
c must be preceded by the include file hec_par.inc
c
      include'hec_max.inc'
c
c pedestal values common
c must be preceded by the include file hec_par.inc
c
      include'hec_ped.inc'
c
c search common
c
      include'hec_search.inc'
c
c tdc common
c
      include'hec_tdc.inc'
c
c trigger common
c
      include'hec_trig.inc'
c
c ntuple common
c
      include'hec_ntuple.inc'
c
      integer i,ic, icount
      integer cell_list(i_adc_dim),current_cell
c
c call pedestal event routine and prefered pedestal filling
c
      call hec_ped_evt
      call hec_ped_fill
c
c check cell energy, if it is above threshold, keep it in a list of 
c "interesting" cells, else throw it away. Also count "interesting" cells.
c.
      icount = 0.
      do ic = 1, i_adc_used
         if ( adc_max_ic(ic,1) .gt. (adc_ped(ic) + 
     +        sigma_ntp*adc_rms(ic))) then
            icount = icount + 1
            cell_list(icount) = ic
         endif
      enddo
c
c do over all "interesting" adc channels 
c
      nt_cells_used = icount
      nt_evntno = i_event
      do i = 1, nt_cells_used
c
c fill ntuple variables for adc max, time max and pedestal
c
        current_cell = cell_list(i)
        nt_ic_index(i) = current_cell
        nt_adcmx(i) = adc_max_ic(current_cell,1)
        nt_timmx(i) = adc_max_ic(current_cell,2)
        nt_pedest(i) = adc_ped(current_cell)
c
c if calibration is turned on, fill ntuple with energy
c
        if (io_cal(1) .ge. 1) then
          nt_ene(i) = hec_cal_ic(current_cell)
        else
          nt_ene(i) = 0.
        endif      
c
      enddo
c
c count channels with signal in them and determine if event is
c good or bad
c
ccc      if (irunpd .ge. 4 .and. hec_s_dk .gt. 0) then
ccc        hec_s_cells=0           ! clear for counting
ccc        do ic = 1, i_adc_used
ccc          if (hec_s_chan(ic)) then
ccc            hec_s_cells=hec_s_cells+1 ! count active cells
ccc            hec_s_count(ic)=hec_s_count(ic)+1
ccc          endif                 ! if (hec_s_chan(ic)) then
ccc        enddo                   ! do ic = 1, i_adc_used
ccc        if (hec_s_cells .eq. 0) then
ccc          nt_evflag = .false.
ccc        else
ccc          nt_evflag = .true.
ccc        endif
ccc      else
ccc        nt_evflag = .true.
ccc      endif                     ! if (irunpd.ge.4) then
      nt_evflag = .true.
c
c fill ntuple variable with trigger value
c
      if (trig_physics) then
        nt_trig = 1 
      endif
      if (trig_e) then
        nt_trig = 2 
      elseif (trig_pi) then
        nt_trig = 3
      elseif (trig_mu) then
        nt_trig = 4
      endif
c
c fill ntuple
c
      call hfnt(102)
c
      return
      end







