      subroutine hec_online_book_ana
c
c book online histograms 
c
      implicit none
c
      include'hec_par.inc'
c
c common for datacard values
c
      include'hec_datacard.inc'
c
c geometry correspondence tables common
c must be preceded by the include file hec_par.inc
c
      include'hec_geo.inc'
c
c online common
c
      include'hec_online.inc'
c
c online histogram id common
c
      include'hec_online_his.inc'
c
c pedestal 
c
      include'hec_ped.inc'
c
c run header common
c
      include'hec_runh.inc'
c
c local variables
c
      integer ic
      character*70 ct
      character*1 cd
      character*4 c4
      real vmax
      real mxrms
      integer nbin
      integer id
c
c check run header to see if adc banks were turned on in this run
c
      call hec_runh_pass
      if (.not. calo_on_flag) then
        print *,' '
        print *,'***WARNING!!!: The ADCs are turned off in run header,', 
     +          '    skipping several histograms (hec_online_book_ana)'
        print *,' '
        return 
      endif
c
c adc pedestal values
c
      id = id_ped
      call hbook1(id, 'adc pedestals', 100, 500., 1500., 0.)
c
      id = id_ped_ic
      call hbook1(id, 'adc pedestals vs ic', i_adc_used, 
     +0.5, i_adc_used + 0.5, 0.)
c
c adc pedestal rms values 
c
      nbin = 100
      mxrms = 
     +real(max(100, 100*(int(vmax(adc_rms, i_adc_used)/100.) + 1)))
      id = id_rms
      call hbook1(id, 'adc pedestals rms', nbin, 0., mxrms, 0.)
c
      id = id_rms_ic
      call hbook1(id, 'adc pedestals rms vs ic', i_adc_used, 
     +0.5, i_adc_used + 0.5, 0.)
c
c maximum versus channel number
c
      nbin = i_adc_used
      ct = 'ave. adc(max) vs. channel number '
      id = id_max_ic
      call hbook1(id,ct,nbin,0.5,i_adc_used+0.5,0.)
c
c book lego map to find beam in each layer 
c
      nbin = 4
      ct = 'map of max values in pads'//cd
      id = id_map
      call hbook2(id,ct,4,0.5,4.5,6,0.5,6.5,10000.)
      id = id_map + 1
      call hbook2(id,ct,4,0.5,4.5,6,0.5,6.5,10000.)
      id = id_map + 2
      call hbook2(id,ct,4,0.5,4.5,6,0.5,6.5,10000.)
c
c book histos which show depth profile for each module
c
      nbin = 3
      ct = 'adc(max) - ped depth profile for module 1 '
      id = id_adc_z + i_z_used + 1
      call hbook1(id, ct, nbin, 0., 3., 0.)
      ct = 'adc(max) - ped depth profile for module 2 '
      id = id_adc_z + i_z_used + 2
      call hbook1(id, ct, nbin, 0., 3., 0.)
c
c time profile in ns (including tdc) for each cell.
c number of bins is a parameter in hec_online_his.inc
c
      do ic = 1, i_adc_used
        write(c4, '(i4)') ic
        ct = 'time + tdc (ns) for channel '//c4
        id = id_timns_ic + ic
        call hbook1(id, ct, ntdc_bin, 0., real(ntdc_bin), 0.)
      enddo
c
c time profile for each channel in 1997
c
      if (irunpd .ge. 4) then
        do ic = 1, i_adc_used
          write(c4, '(i4)') ic
          ct = 'time profile for channel '//c4
          id = id_tprof_ic + ic
          call hbook1(id,ct,i_tim_used,0.5,real(i_tim_used)+0.5,0.)
        enddo
      endif
c
      end













