      subroutine hec_online_book_ini
c
c book online histograms 
c
c this booking routine is called before the pass over events
c it should only be used to book histos that must be filled 
c every event. All other histos are booked in the book_ana
c routine
c
      implicit none
c
      include'hec_par.inc'
c
c common for datacard values
c
      include'hec_datacard.inc'
c
c geometry correspondence tables common
c must be preceded by the include file hec_par.inc
c
      include'hec_geo.inc'
c
c online common
c
      include'hec_online.inc'
c
c online histogram id common
c
      include'hec_online_his.inc'
c
c pedestal 
c
      include'hec_ped.inc'
c
c run header common
c
      include'hec_runh.inc'
c
c local variables
c
      integer i_z, ic
      character*70 ct
      character*1 cd
      character*4 c4
      integer nbin
      integer id
c
c zero our moments arrays
c
      call vzero(adcmom,i_adc_dim*i_tim_dim*3)
      call vzero(maxmom,i_adc_dim*3)   
c
c set flag for first pass though analysis (to allow new histogram file)
c
      print *, ' *** booking online histograms'
c
c tdc distribution 
c
      nbin = 100
      write(c4, '(i4)') ic
      ct = 'tdc distribution (ns) '//c4
      id = id_tdc 
      call hbook1(id, ct, nbin, 0., 50., 0.)
c
c check run header to see if adc banks were turned on in this run
c
      call hec_runh_pass
      if (.not. calo_on_flag) then
        print *,' '
        print *,'*** WARNING!!: The ADCs are turned off in run header,', 
     +          '    skipping several histograms (hec_online_book_ini)'
        print *,' '
        return 
      endif
c
c adc(max)-ped distribution for each depth
c
      nbin = 100
      do i_z = 1, i_z_used
        write(cd, '(i1)') i_z
        ct = 'adc(max) - ped for tower depth '//cd
        id = id_adc_z + i_z
        call hbook1(id, ct, nbin, 1., -1., 0.)
      enddo
c
c adc(max)-ped distribution for each channel
c
      nbin = 100
      do ic = 1, i_adc_used
        write(c4, '(i4)') ic
        ct = 'adc(max) - ped for channel '//c4
        id = id_adc_ic + ic
        call hbook1(id, ct, nbin, 0., 2000., 0.)
      enddo
c
c time(max) distribution in samplings for each channel for 1997 or later
c
      if (irunpd .ge. 4) then
        nbin = 100
        do ic = 1, i_adc_used
          write(c4, '(i4)') ic
          ct = 'time(max) for channel '//c4//' (time slice)'
          id = id_tim_ic + ic
          call hbook1(id, ct, nbin, 0.5 , i_tim_used+0.5 , 0.)
        enddo
      endif
c
c time(max) distribution in ns (TDC corrected) for each channel 
c for 1997 or later
c
      if (irunpd .ge. 4) then
        nbin = 500
        do ic = 1, i_adc_used
          write(c4, '(i4)') ic
          ct = 'time(max)+TDC for channel '//c4//' (ns)'
          id = id_tim_icns + ic
          call hbook1(id, ct, nbin, 0.5 , nbin+0.5 , 0.)
        enddo
      endif
c
c calibrated energy for each channel, if calibration is turned on
c
      nbin = 100
      do ic = 1, i_adc_used
        write(c4, '(i4)') ic
        ct = 'energy in nA for channel '//c4
        id = id_cal_ic + ic
        call hbook1(id, ct, nbin, 1., -1., 0.)  
      enddo
c
c calibrated energy if above sigma cut
c
      ct = 'energy in nA for channels above 1 sigma '
      id = id_sigma + 1
      call hbook1(id, ct, nbin, 1., -1., 0.)  
      ct = 'energy in nA for channels above 2 sigma '
      id = id_sigma + 2
      call hbook1(id, ct, nbin, 1., -1., 0.)  
      ct = 'energy in nA for channels above 3 sigma '
      id = id_sigma + 3
      call hbook1(id, ct, nbin, 1., -1., 0.)  
c
c muon tower histos
c
      nbin = 500
      ct = 'Muon energy(nA) tower (3,13,23,41) '
      id = id_muon_tower + 1
      call hbook1(id, ct, nbin, 1., -1., 0.)  
      ct = 'Muon energy(nA) tower (5,15,41,143) '
      id = id_muon_tower + 2
      call hbook1(id, ct, nbin, 1., -1., 0.)  
      ct = 'Muon energy(nA) tower (76,86,96,114) '
      id = id_muon_tower + 3
      call hbook1(id, ct, nbin, 1., -1., 0.)        
      ct = 'Muon energy(nA) tower (78,88,114,116) '
      id = id_muon_tower + 4
      call hbook1(id, ct, nbin, 1., -1., 0.)        
c
c muon towers in ADC counts
c        
      nbin = 100
      ct = 'Muon ADC-ped sum tower (3,13,23,41) '
      id = id_muon_tower + 101
      call hbook1(id, ct, nbin, 0., 100., 0.)  
      ct = 'Muon ADC-ped sum tower (5,15,41,143) '
      id = id_muon_tower + 102
      call hbook1(id, ct, nbin, 0., 100., 0.)  
      ct = 'Muon ADC-ped sum tower (76,86,96,114) '
      id = id_muon_tower + 103
      call hbook1(id, ct, nbin, 0., 100., 0.)        
      ct = 'Muon ADC-ped sum tower (78,88,114,116) '
      id = id_muon_tower + 104
      call hbook1(id, ct, nbin, 0., 100., 0.)      
c
c fadc  histograms (8 fadc channels)
c
      do ic = 1, i_fa_cdim 
         write(c4, '(i4)') ic
         ct = 'fadc counts in channel '//c4
         id = id_fadc + ic
         call hbook1(id, ct, 100, 0.5, 100.5, 0.)
      enddo           
c
      print *, ' *** end of online histogram booking'
      end













