      subroutine hec_online_hisevt
c
      implicit none
c
c geometry correspondence tables
c
      include'hec_par.inc'
      include'hec_geo.inc'
c
c adc values common
c
      include'hec_adc.inc' 
c
c calibration common
c
      include'hec_cal.inc'
c
c datacard common
c
      include'hec_datacard.inc'
c
c event information
c
      include'hec_evth.inc'
c
c flash adc common
c
      include'hec_fadc.inc'
c
c pedestal values common
c
      include'hec_ped.inc'
c
c max adc and time values common
c
      include'hec_max.inc'
c
c online histogram id common
c
      include'hec_online.inc'
      include'hec_online_his.inc'
c
c run header common
c
      include'hec_runh.inc'
c
c tdc values common
c
      include'hec_tdc.inc'
c
c trigger common
c
      include'hec_trig.inc'
c
c local variables
c
      real sig, sig_sum(1:i_z_max)
      integer ic, i_t, i_z, id, nid, nid1, nid2, nid3, ibin
c
      real scale, sum_1sig, sum_2sig, sum_3sig
c
      integer nmucells
      parameter (nmucells = 4)
      integer imu
      real sum_muon1, sum_muon2, sum_muon3, sum_muon4
      real sum_muon1_adc,sum_muon2_adc, sum_muon3_adc, sum_muon4_adc
      integer mulist1(nmucells),mulist2(nmucells),
     + mulist3(nmucells),mulist4(nmucells)
c
      real maxns
c
c choose cells to be included in muon towers
c
      data mulist1/3,13,23,41/
      data mulist2/5,15,41,143/
      data mulist3/76,86,96,114/
      data mulist4/78,88,114,116/
c
c fill tdc distribution histo
c
      nid1 = 0
      id = id_tdc 
      call hff1(id, nid1, hec_tdc_ns, 1.)        
c
c fill flash adc histogram for each fadc channel
c
      if (lpat_1(10) .and. firstfadc) then
        do ic = 1, i_fa_cdim
          do i_t = 1, i_fa_tdim
            id = id_fadc + ic
            call hfill(id,real(i_t), 0., real(i_fadc_ic_t(ic,i_t)))
          enddo
        enddo
        firstfadc = .false.
      endif
c
c if there are no adc banks (ie. run header says they are turned off)
c do not fill histos
c
      if (.not. calo_on_flag) then
        if (i_event .le. 2) then
          print *,' '
          print *,'*** WARNING!!!:ADCs not read out, skipping '
     +    ,       '               histogram filling (hec_online_hisevt)'
          print *,' '
        endif
        return
      endif
c
c initialize sums
c
      sum_1sig = 0.
      sum_2sig = 0.
      sum_3sig = 0.
c
      sum_muon1 = 0.
      sum_muon2 = 0.
      sum_muon3 = 0.
      sum_muon4 = 0.
c
      sum_muon1_adc = 0.
      sum_muon2_adc = 0.
      sum_muon3_adc = 0.
      sum_muon4_adc = 0.
c
      call vzero(sig_sum, i_z_max)
c
c begin filling histograms
c
      do ic = 1, i_adc_used
        sig = adc_max_ic(ic, 1) - adc_ped_evt(ic)
c
c fill adc(max)-ped histograms for each channel
c
        if (ic .eq. 1) nid = 0
        id = id_adc_ic + ic
        call hff1(id, nid, sig, 1.)
c
c fill time(max) histograms for each channel for 1997 and later
c
        if (irunpd .ge. 4) then
          if (i_event .eq. 1) nid2 = 0
          id = id_tim_ic + ic
          call hff1(id, nid2, adc_max_ic(ic, 2), 1.)
        endif
c
c fill time(max) histograms with TDC correction 
c for each channel for 1997 and later
c
        if (irunpd .ge. 4) then
          if (i_event .eq. 1) nid3 = 0
          id = id_tim_icns + ic
          maxns = (adc_max_ic(ic,2)-1.)*25.
          call hff1(id, nid3, maxns + hec_tdc_ns, 1.)
ccc          call hfill(id, nint(maxns+hec_tdc_ns), 0., 1.)
        endif
c
c accumulate moments to later fill time profile histograms for each 
c channel for 1997 and later
c
        if (irunpd .ge. 4) then
          do i_t = 1, i_tim_used
            adcmom(ic,i_t,1) = adcmom(ic,i_t,1) + 1.0
            adcmom(ic,i_t,2) = adcmom(ic,i_t,2) + 
     +                         real((i_adc_ic_t(ic, i_t)))
            adcmom(ic,i_t,3) = adcmom(ic,i_t,3) + 
     +                         (real((i_adc_ic_t(ic, i_t))))**2
c
            ibin = int((i_t-1)*25. + (hec_tdc_ns))
            tdcmom(ic,ibin,1) = tdcmom(ic,ibin,1) + 1.
            tdcmom(ic,ibin,2) = tdcmom(ic,ibin,2) +
     +                        i_adc_ic_t(ic,i_t) 
            tdcmom(ic,ibin,3) = tdcmom(ic,ibin,3) +
     +                        (i_adc_ic_t(ic,i_t))**2 
          enddo
        endif
c
c accumulate moments to later fill histo containing average maximum for
c each channel 
c
        maxmom(ic,1) = maxmom(ic,1) + 1.0
        maxmom(ic,2) = maxmom(ic,2) + adc_max_ic(ic,1)
        maxmom(ic,3) = maxmom(ic,3) + adc_max_ic(ic,1)**2
c
c fill histograms of energy in nA for each channel, 
c
        id = id_cal_ic + ic
        scale=1.
        call hfill(id, hec_cal_ic(ic)/scale, 0., 1.)
c
c tabulate sums for energy histograms with maximums above certain 
c sigma cut from peds
c
        if ((adc_max_ic(ic,1) - 
     +      (adc_ped_evt(ic)+adc_rms_evt(ic)))
     +       .gt. 0)then
          sum_1sig = sum_1sig + hec_cal_ic(ic)
        endif
        if((adc_max_ic(ic,1) - 
     +         (adc_ped_evt(ic)+2.*adc_rms_evt(ic)))
     +       .gt. 0)then     
          sum_2sig = sum_2sig + hec_cal_ic(ic)
        endif
        if((adc_max_ic(ic,1) - 
     +         (adc_ped_evt(ic)+3.*adc_rms_evt(ic)))
     +       .gt. 0)then 
          sum_3sig = sum_3sig + hec_cal_ic(ic)    
        endif
c
c collect sums to fill 4 special muon towers (4 cells each -> imu) 
c for maximum use value of 8th time sample....not cubic fit
c ....and subtract pedestal
c
        do imu = 1, 4
           if (ic .eq. mulist1(imu) .and. trig_mu) then
              sum_muon1 = sum_muon1 + hec_cal_ic(ic)
              sum_muon1_adc = sum_muon1_adc + (i_adc_ic_t(ic, 8)
     +                         - adc_ped_evt(ic))
           elseif (ic .eq. mulist2(imu) .and. trig_mu) then
              sum_muon2 = sum_muon2 + hec_cal_ic(ic)
              sum_muon2_adc = sum_muon2_adc + (i_adc_ic_t(ic, 8)
     +                         - adc_ped_evt(ic))               
           elseif (ic .eq. mulist3(imu) .and. trig_mu) then
              sum_muon3 = sum_muon3 + hec_cal_ic(ic)
              sum_muon3_adc = sum_muon3_adc + (i_adc_ic_t(ic,8)
     +                         - adc_ped_evt(ic))
           elseif (ic .eq. mulist4(imu) .and. trig_mu) then
              sum_muon4 = sum_muon4 + hec_cal_ic(ic)
              sum_muon4_adc = sum_muon4_adc + (i_adc_ic_t(ic,8)
     +                         - adc_ped_evt(ic))
           endif
        enddo
c
c sum adc(max)-ped for each tower depth
c
        i_z = ictoph(ic,3)
        if (i_z .gt. 0) then
          sig_sum(i_z) = sig_sum(i_z) + sig
        endif
c
      enddo
c
c fill special muon towers
c
      if (trig_mu) then
        id = id_muon_tower + 1
        call hfill(id, sum_muon1, 0., 1.)
        id = id_muon_tower + 2
        call hfill(id, sum_muon2, 0., 1.)
        id = id_muon_tower + 3
        call hfill(id, sum_muon3, 0., 1.)
        id = id_muon_tower + 4
        call hfill(id, sum_muon4, 0., 1.)
c
        id = id_muon_tower + 101
        call hfill(id, sum_muon1_adc, 0., 1.)
        id = id_muon_tower + 102
        call hfill(id, sum_muon2_adc, 0., 1.)
        id = id_muon_tower + 103
        call hfill(id, sum_muon3_adc, 0., 1.)
        id = id_muon_tower + 104
        call hfill(id, sum_muon4_adc, 0., 1.)
      endif
c
c fill sigma cut energy histos
c
      id = id_cal_ic + 1001
      call hfill(id, sum_1sig/scale, 0., 1.)
      id = id_cal_ic + 1002
      call hfill(id, sum_2sig/scale, 0., 1.)
      id = id_cal_ic + 1003
      call hfill(id, sum_3sig/scale, 0., 1.)
c
c fill adc(max)-ped histograms for each depth
c
      do i_z = 1, i_z_used
        call hfill(id_adc_z + i_z,sig_sum(i_z),0.,1.)
      enddo
c
      return
      end











