      subroutine hec_online_hisview
c
c allow viewing of online histogram files in higz window
c
      implicit none
c
      include'hec_paw.inc'
c
c parameter and geometry commons
c
      include'hec_par.inc'
      include'hec_geo.inc'
c
c run header common
c
      include'hec_runh.inc'
c
c datacard common
c
      include'hec_datacard.inc'
c
c online histogram number common
c
      include'hec_online_his.inc'
c
c define flag that determines what is included in .ps file
c define flag that determines whether zoom button has been pushed
c
      logical psbutton, zoombutton, zoomstatus
c
c local variables
c
      integer hisnum, sig_index(i_adc_used),ic,high_ic(5)
      integer hisorg
      character*5 chidh
      character*20 comment
c
      call hplint(1)
      call hplopt('STAT',1)
c
      hisnum = -1
      zoomstatus = .false.
c
c use cernlib sorting routine to find highest energy cells
c write ic of 5 highest energy cells to a text file if we are in 
c script controlled "autorun" mode.
c
      call sortzv(average_max,sig_index,i_adc_used,1,1,0)
      if (auto_run .eq. 1) then
        open(35,file="highcell.list",status="NEW")
        write(35, *) run_no
        write(35, '(5i3)') (sig_index(ic), ic = 1, 5)
        close(35)
      endif
c
c copy five highest cells to special array for use in choosing 
c histograms
c
      do ic = 1, 5
        high_ic(ic) = sig_index(ic)
      enddo
c
c start with a zone 1 2 noise plot
c
      call igmeta(0,0)
      call hec_online_hisdispl(9990,high_ic,int(run_no),zoomstatus)
      call iuwk(0,1)
      call igterm
c
c fill the run summary postscript file
c
      open(unit=15,file='run_summary.ps',form='formatted',
     +     status='unknown')
      call igmeta(-15,-111)
      call hec_online_hisdispl(9990,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9991,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9992,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9993,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9994,high_ic,run_no,zoomstatus)
      call hec_online_hisdispl(9995,high_ic,run_no,zoomstatus)
      call igmeta(999,0)
      close(15)
c
c list histograms
c
ccc      call hldir('//PAWC',' ')
      call hec_online_menu
      if (.not. calo_on_flag) then
        print *,' '
        print *,'WARNING!!!: no ADCs read for this run,'
     +         ,'            most histograms not available'
        print *,' '
      endif
c
c open user summary ps file
c
      open(unit=10,file='user_summary.ps',form='formatted',
     +status='unknown')
c
c while the user has not entered 0 as a histogram number
c
      do while (hisnum .ne. 0)
c
c choose zone 1 1 for plot
c
        call hplzon(1,1,1,' ')
c
c prompt user for histogram number and read from keyboard
c
        print *, ' ***ENTER 9999 TO LIST HISTOGRAMS'
        print *, ' ***ENTER HISTOGRAM NUMBER TO DISPLAY'
        print *, ' ***ENTER 0 TO GO TO PRINT MENU (EXIT HISTO MENU)'
        read(5,*,ERR=10) hisnum
c
        if (hisnum .ne. 0) then
c
c reset flags
c
          psbutton = .false.
          zoombutton = .false.
c
c send output to graphical window only
c
          call igmeta(0,-111)
c
c call routine which knows how to display each histogram (all the fancy 
c labels etc.)
c
          call hec_online_hisdispl(hisnum,high_ic,run_no,zoomstatus)
c
c display and read buttons if chosen histo is not a control or run 
c summary number
c
          if (abs(hisnum) .lt. 9000 .or. abs(hisnum) .gt. 10000) then
c
c instruct user
c
            print *,'############################################### '
            print *,'Click left mouse button on PS to add histogram',
     +              ' to user summary'
            print *,'############################################### '
            print *,'Click left mouse button on ZOOM to zoom on ', 
     +              'histogram'
            print *,'############################################### '
            print *,'Click right mouse button on histogram to return ',
     +               'to histogram menu' 
            print *,'############################################### '
c
            call hec_online_hisbut(psbutton,zoombutton)
          endif
c
c control over display is now given to HIGZ window and mouse
c as long as user always presses a button, the loop continues.
c right mouse button exits
c
c a zoom will change the current histogram number (hisnum), keep the
c original as hisorg
c
          zoomstatus = .false.
          hisorg = hisnum
          do while (psbutton .or. zoombutton)
c
c if user has chosen zoom button, zoom on displayed plot
c
c zoomed plot has histo id > 1100000
c
            if (zoombutton) then
              hisnum = 9900
              call hec_online_hisdispl(hisnum,high_ic,run_no,zoomstatus)
              zoomstatus = .true.
c
c if user has chosen .ps button, put plot directly to ps (no display)
c
            elseif (psbutton) then
              call igmeta(-10,-111)
                call hec_online_hisdispl(hisnum,high_ic,run_no,
     +                                   zoomstatus)                
            endif
c
c
c if either this routine has just zoomed 
c add a comment to the plot
c
            if (zoomstatus) then
              call izitoc(hisorg,chidh)
              comment = 'Zoom on '//chidh
              call hplsof(12.,18.2,comment,0.5,0.,0.,-1.)
            endif
c
c reset display to go only to screen (not .ps)
c
            call igmeta(0,-111)
c
c
c instruct user
c
            print *,'############################################### '
            print *,'Click left mouse button on PS to add histogram',
     +              ' to user summary'
            print *,'############################################### '
            print *,'Click left mouse button on ZOOM to zoom on ', 
     +              'histogram'
            print *,'############################################### '
            print *,'Click right mouse button on histogram to return ',
     +               'to histogram menu' 
            print *,'############################################### '
c
            call hec_online_hisbut(psbutton,zoombutton)
c
          enddo
c
        endif
c
        call igterm
c
c if no error (ie got to here) skip error handling block
c
        goto 11
 10     continue
        print *, ' ***Not a valid histogram number'
        hisnum = -1
 11     continue
c
      enddo
c
c terminate hplot
c
      call hplend
      close(unit=10)
c
      return
      end


