      subroutine hec_online_mwpc
*************************************************************************
***
***   Get MWPC clusters and fill the beam profile histograms
***
*************************************************************************
      implicit none
      include 'hec_dwpc.inc'
      include 'hec_beam_sys_config.inc'
      include 'hec_evth.inc'       
C===   Local variables
      logical first
      save first
C===
      character*80 htit
C===
      integer i, iword, icha, ixy, idh, id, icent, nwires, n1, n2
      real coor, ch_width
C===
      data first/.true./
      data idh/5200/
C===   Book histograms
ccc      if (first) then
ccc      print *,'i_event is ',i_event
ccc
       if (i_event .le. 1) then
       first=.false.
       call hec_beam_ini
       htit='Beam profile, x plane 2  (wire no.)$'
       call hbook1(idh+2,htit,128,0.0,128.,0.)
       htit='Beam profile, y plane 2  (wire no.)$'
       call hbook1(idh+7,htit,128,0.0,128.,0.)
       htit='Beam profile, x plane 3  (wire no.)$'
       call hbook1(idh+3,htit,128,0.0,128.,0.)
       htit='Beam profile, y plane 3  (wire no.)$'
       call hbook1(idh+8,htit,128,0.0,128.,0.)
       htit='Beam profile, x plane 4  (wire no.)$'
       call hbook1(idh+4,htit,128,0.0,128.,0.)
       htit='Beam profile, y plane 4  (wire no.)$'
       call hbook1(idh+9,htit,128,0.0,128.,0.)
       htit='Beam profile, x plane 5  (wire no.)$'
       call hbook1(idh+5,htit,64,0.0,64.,0.)
       htit='Beam profile, y plane 5  (wire no.)$'
       call hbook1(idh+10,htit,64,0.0,64.,0.)
C===
       id=idh+10
       htit='Beam profile, x plane 2  (cm)$'
       call hbook1(id+2,htit,128,-6.4,6.4,0.)
       htit='Beam profile, y plane 2  (cm)$'
       call hbook1(id+7,htit,128,-6.4,6.4,0.)
       htit='Beam profile, x plane 3  (cm)$'
       call hbook1(id+3,htit,128,-6.4,6.4,0.)
       htit='Beam profile, y plane 3  (cm)$'
       call hbook1(id+8,htit,128,-6.4,6.4,0.)
       htit='Beam profile, x plane 4  (cm)$'
       call hbook1(id+4,htit,128,-6.4,6.4,0.)
       htit='Beam profile, y plane 4  (cm)$'
       call hbook1(id+9,htit,128,-6.4,6.4,0.)
       htit='Beam profile, x plane 5  (cm)$'
       call hbook1(id+5,htit,64,-6.4,6.4,0.)
       htit='Beam profile, y plane 5  (cm)$'
       call hbook1(id+10,htit,64,-6.4,6.4,0.)
      endif
      if (n_dwpc.le.0) return
C===    Fill histograms
      do iword=1,n_dwpc
       if (dwpc_words(iword).ne.0) then
        call hec_beam_xymwpc(dwpc_words(iword),icha,ixy,coor,ch_width)
        id=idh+10+icha
        if (ixy.eq.-1) id=id+5
        call hf1(id,coor,1.0)
c
        if (step(icha) .gt. 0.) then
          icent=(coor+hsize(icha))/step(icha)
          nwires=nint(2.*ch_width/step(icha))
        endif
c
        n1=icent-(nwires-1)/2
        n2=n1+nwires-1
        id=id-10
        do i=n1,n2
         call hf1(id,float(i),1.)
        enddo
       endif				! dwpc_words(iword).ne.0
      enddo
C
      return
      end








